#define UNICODE
#define _UNICODE
#include <windows.h>
#include <windowsx.h>
#include <shlwapi.h>
#include <commctrl.h>
#include <malloc.h>
#include <tchar.h>
#include <richedit.h>
#pragma comment(linker,"/NOD /OPT:NOWIN98")
#pragma intrinsic(memset)
#define elemof(x) (sizeof(x)/sizeof(*(x)))
enum{
  MB_SOUND	=0x80000000,
};

static HINSTANCE hInstance;
static HWND hMainWnd,hDialog;
static HWND hToolbar,hEdit,hStatus;
static HWND hFind;
static UINT msgFind;
static FINDREPLACE findreplace;
static TCHAR findstr[80],replacestr[80];
static HMENU hMainMenu;
static TCHAR MBoxTitle[64];
static TCHAR ExeName[MAX_PATH];
static TCHAR BakName[MAX_PATH];

static int vMBox(HWND parent,ULONG_PTR id, UINT flags, va_list va) {
  TCHAR s[256],tbuf[256],*t=tbuf;
  if (IS_INTRESOURCE(id)) LoadString(hInstance,(UINT)id,tbuf,elemof(tbuf));
  else t=(TCHAR*)id;
  s[_vsntprintf(s,elemof(s)-1,t,va)]=0;
  if (flags&MB_SOUND) MessageBeep(flags&MB_ICONMASK);
  return MessageBox(parent,s,MBoxTitle,flags&~MB_SOUND);
}

static int _cdecl MBox(HWND parent,ULONG_PTR id,UINT flags,...) {
  va_list va;
  va_start(va,flags);
  int r=vMBox(parent,id,flags,va);
  va_end(va);
  return r;
}

template<class T> int StrReplace(T*s,int slen,int buflen,int idel, int ldel, const T*sins,int lins);

static int StrReplace<char>(char*s,int slen,int buflen,int idel, int ldel, const char*sins,int lins) {
  if (buflen<4) return 0;
  if (slen<0) slen=lstrlenA(s)+1;
  if ((unsigned)idel>=(unsigned)slen) return 0;
  if (lins<0) lins=lstrlenA(sins);
  int move=lins-ldel;	// amount of grow
  if ((unsigned)(slen+move)>(unsigned)buflen) return 0;
  MoveMemory(s+idel+lins,s+idel+ldel,slen-idel-ldel);
  CopyMemory(s+idel,sins,lins);
  return slen+move;
}

static int StrReplace<WCHAR>(WCHAR*s,int slen,int buflen,int idel, int ldel, const WCHAR*sins,int lins) {
  if (buflen<4) return 0;
  if (slen<0) slen=lstrlenW(s)+1;
  if ((unsigned)idel>=(unsigned)slen) return 0;
  if (lins<0) lins=lstrlenW(sins);
  int move=lins-ldel;	// amount of grow
  if ((unsigned)(slen+move)>(unsigned)buflen) return 0;
  MoveMemory(s+idel+lins,s+idel+ldel,(slen-idel-ldel)*2);
  CopyMemory(s+idel,sins,lins*2);
  return slen+move;
}

static struct Node{
  enum type_t{
    root,Element,Attr,Text,CDATASection,EntityReference,Entity,ProcessingInstruction,Comment,Document,DocumentType,DocumentFragment,Notation
  }type;
//  int depth;
  CHARRANGE scope,name,value;
  Node*next,*sub;
  static TCHAR*buf;
  static HANDLE heap;
  Node() {}
  Node(type_t t,int a, int e):type(t) {scope.cpMin=a; scope.cpMax=e;}
  static void*operator new(size_t sz) {return HeapAlloc(heap,HEAP_ZERO_MEMORY,sz);}
  static void operator delete(void*) {}	// don't delete
  int build(int);
  Node*&lastsub() {if (sub) {Node**p=&sub; while ((*p)->next) p=&((*p)->next); return *p;} return sub;}
  void addsub(Node*n) {lastsub()=n;}
  Node*last() {Node*p=this; while (p->next) p=p->next; return p;}
  void addnext(Node*n) {last()->next=n;}
}*xml;

int Node::build(int start) {
  for (int i=scope.cpMin; i<scope.cpMax; i++) {
    int j;
    if (buf[i]<=' ') continue;
    if (buf[i]=='<') switch (buf[++i]) {
      case '/': {
	for (j=++i; j<scope.cpMax; j++) {
	  if (buf[j]=='>') {
	    if (j!=i) {	// Not only "</>"
	      if (j-i != name.cpMax-name.cpMin) return -1;	// Error! Tag must have same length
	      if (memcmp(buf+name.cpMin,buf+i,(j-i)*sizeof(TCHAR))) return -1;	// Error! Tag must be the same
	    }
	    scope.cpMax=j+1;
	    value.cpMax=i-2;
	    return j+1;
	  }
	}
      }break;
      case '?': {
        Node*n=new Node(Entity,i-1,scope.cpMax);
	for (j=++i; j<scope.cpMax; j++) {
	  if (buf[j]=='>') {
	    n->scope.cpMax=j+1;
	    n->value.cpMin=i+1;
	    n->value.cpMax=j;
	    addnext(n);
	    break;
	  }
	}
	i=j;
      }break;
      case '!': {
        Node*n=new Node(Comment,i-1,scope.cpMax);
	for (j=++i; j<scope.cpMax; j++) {
	  if (buf[j]=='>') {
	    n->scope.cpMax=j+1;
	    n->value.cpMin=i+1;
	    n->value.cpMax=j;
	    addnext(n);
	    break;
	  }
	}
	i=j;
      }break;
      default: {
        Node*n=new Node(Element,i-1,scope.cpMax);
        for (; j<scope.cpMax; j++) {
	  if (buf[j]<=' ' || buf[j]=='>') break;
	}
	n->name.cpMin=i;
	n->name.cpMax=j;
	for(i=j;buf[i]!='>';i++) {	// collect attributes
	  if (buf[i]<=' ') continue;	// go over whitespace
	  if (buf[i]=='/') {
	    if (buf[i+1]!='>') return -1;	// malformed!
	    n->value.cpMin=n->value.cpMax=n->scope.cpMax=i+2;
	    return i+2;
	  }
	  else if (buf[i]=='>') {
	    i=n->build(i);
	  }else for (j=i; j<scope.cpMax; j++) {
	    if (buf[j]<=' ' || buf[j]=='=') {
	      Node*k=new Node(Attr,i,scope.cpMax);
	      k->name.cpMin=i;
	      k->name.cpMax=j;
	      if (buf[j]=='=') {
	        TCHAR q=buf[++j];
	        if (q!='"' && q!='\'') return -1;	// must be in single or double quotes for XML, not for HTML
		k->value.cpMin=++j;
		for(;j<scope.cpMax;j++) {
		  if (buf[j]==q) {
		    k->value.cpMax=j;
		    n->addsub(k);
		    break;
		  }
		}
	      }
	    }
	  }
	}
      }
    }
  }
  return -1;
}

TCHAR*Node::buf;
HANDLE Node::heap;

static void classify() {
  Node::heap=HeapCreate(HEAP_NO_SERIALIZE,0,0);
  int l=SendMessage(hEdit,WM_GETTEXTLENGTH,0,0);
  Node::buf=(TCHAR*)HeapAlloc(Node::heap,0,(l+1)*sizeof(TCHAR));
  GetWindowText(hEdit,Node::buf,l+1);
  xml=new Node(Node::root,0,l);
  xml->build(0);

  FINDTEXT ft={{0,-1},TEXT("<dpiAware>")};
  int i=SendMessage(hEdit,EM_FINDTEXT,0,(LPARAM)&ft);
  ft.lpstrText=TEXT(">true/PM<");
  int j=SendMessage(hEdit,EM_FINDTEXT,0,(LPARAM)&ft);
  CheckMenuRadioItem(hMainMenu,310,311,j>=0?311:i>=0?310:0,0);
  HeapDestroy(Node::heap);
}

static void indent() {
}

static int getmanifest() {
  HMODULE hExe=LoadLibraryEx(ExeName,0,LOAD_LIBRARY_AS_DATAFILE);
  if (!hExe) {
    MBox(hMainWnd,2,MB_OK,ExeName);
    return -2;
  }
  HRSRC hRes=FindResource(hExe,MAKEINTRESOURCE(1),RT_MANIFEST);
  if (!hRes) {
    FreeLibrary(hExe);
    return 0;
  }
  HGLOBAL h1=LoadResource(hExe,hRes);
  if (!h1) return -4;
  const char*m=(const char*)LockResource(h1);
  if (!m) return -5;
  int l=MultiByteToWideChar(CP_UTF8,0,m,-1,0,0);
  WCHAR*ws=(WCHAR*)_alloca(l*2);
  MultiByteToWideChar(CP_UTF8,0,m,-1,ws,l);
  SetWindowText(hEdit,ws);
  UnlockResource(h1);
  FreeLibrary(hExe);
  classify();
  return 1;
}

static bool makebakname() {
  lstrcpyn(BakName,ExeName,elemof(BakName));
  int i=PathFindExtension(BakName)-BakName;
  return StrReplace(BakName,-1,elemof(BakName),i,0,TEXT("~"),-1)>0;
}

static bool revert(HWND parent) {
  if (MoveFileEx(BakName,ExeName,MOVEFILE_REPLACE_EXISTING)) {
    EnableMenuItem(hMainMenu,104,MF_GRAYED);
    MBox(parent,5,MB_OK|MB_ICONINFORMATION,ExeName);
    getmanifest();
    return true;
  }
  MBox(parent,6,MB_OK|MB_ICONEXCLAMATION|MB_SOUND,ExeName);
  return false;
}

// apply changes
static bool apply(HWND parent) {
// If no backup file exists, create one. Existence is marked in MainMenu id 104.
  if (GetMenuState(hMainMenu,104,0)&MF_GRAYED) {
    if (CopyFile(ExeName,BakName,TRUE)) {
      EnableMenuItem(hMainMenu,104,MF_ENABLED);
    }else if (MBox(parent,3,MB_YESNO|MB_ICONQUESTION|MB_SOUND)!=IDYES) return false;
  }
// Now use XxxUpdateResource functions to modify the executable file
  HANDLE hUpdate=BeginUpdateResource(ExeName,FALSE);
  if (!hUpdate) {
    MBox(parent,4,MB_OK|MB_ICONEXCLAMATION|MB_SOUND);
    return false;
  }
  int lw=GetWindowTextLength(hEdit)+1;
  WCHAR*sw=(WCHAR*)_alloca(lw*2);
  GetWindowText(hEdit,sw,lw);
  int lu=WideCharToMultiByte(CP_UTF8,0,sw,lw,0,0,0,0);
  char*su=(char*)_alloca(lu);
  WideCharToMultiByte(CP_UTF8,0,sw,lw,su,lu,0,0);
  if (!UpdateResource(hUpdate,RT_MANIFEST,MAKEINTRESOURCE(2),0,su,lu)) {
    MBox(parent,4,MB_OK|MB_ICONEXCLAMATION|MB_SOUND);
    return false;
  }
  if (!EndUpdateResource(hUpdate,FALSE)) {
    MBox(parent,4,MB_OK|MB_ICONEXCLAMATION|MB_SOUND);
    return false;
  }
  MBox(parent,7,MB_OK|MB_ICONINFORMATION);
  EnableMenuItem(hMainMenu,102,MF_GRAYED);
  return true;
}

#if 0
  char manifest[2048];
  int r=getmanifest(exename,manifest,sizeof manifest);
  if (r<0) return r;
  static const char dpiaware[]=
    "<asmv3:application xmlns:asmv3=\"urn:schemas-microsoft-com:asm.v3\">"
    "<asmv3:windowsSettings xmlns=\"http://schemas.microsoft.com/SMI/2005/WindowsSettings\">"
    "<dpiAware>true</dpiAware></asmv3:windowsSettings></asmv3:application>";
  if (!r) {
    if (remove) {
      MBox(TEXT("No manifest resource"));
      return -3;
    }
    MBox(TEXT("Create NEW manifest"));
    wnsprintfA(manifest,sizeof manifest,"%s%s%s",
      "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>"
      "<assembly xmlns=\"urn:schemas-microsoft-com:asm.v1\" manifestVersion=\"1.0\">",
      dpiaware,
      "<dependency><dependentAssembly>"
      "<assemblyIdentity type=\"win32\" name=\"Microsoft.Windows.Common-Controls\" version=\"6.0.0.0\" "
      "processorArchitecture=\"*\" publicKeyToken=\"6595b64144ccf1df\" language=\"*\" />"
      "</dependentAssembly></dependency></assembly>");
  }else{
    char*f=StrStrA(manifest,"dpiAware");
    if (f && !remove) {
      MBox(TEXT("%s manifest already contains 'dpiAware'"),exename);
      return -6;
    }
    if (remove) {
      if (!f) {
	MBox(TEXT("%s manifest has no 'dpiAware'"),exename);
	return -8;
      }
      f=StrStrA(manifest,"<asmv3:application");
      char*f2=StrStrA(manifest,"</asmv3:application>");
      if (!f || !f2 || f2-f<0) {
	MBox(TEXT("%s dpiAware manifest malformed"),exename);
	return -9;
      }
      StrReplace(manifest,-1,sizeof manifest,f-manifest,f2+20-f,"",0);
    }else{
      f=StrStrA(manifest,"<dependency>");
      if (!f) {
	MBox(TEXT("%s manifest has no <dependency> section"),exename);
	f=StrStrA(manifest,"</assembly>");
	if (!f) {
	  MBox(TEXT("%s manifest has no <assembly> section"),exename);
	  return -7;
	}
      }
      StrReplace(manifest,-1,sizeof manifest,f-manifest,0,dpiaware,-1);
    }
  }
}
#endif


static bool openfile(HWND parent) {
  OPENFILENAME ofn;
  ZeroMemory(&ofn,sizeof ofn);
  ofn.lStructSize=sizeof ofn;
  ofn.hwndOwner=parent;
  ofn.lpstrFile=ExeName;
  ofn.nMaxFile=elemof(ExeName);
  ofn.Flags=OFN_HIDEREADONLY|OFN_FILEMUSTEXIST;
  TCHAR f[64];
  f[LoadString(hInstance,8,f,elemof(f)-1)+1]=0;
  ofn.lpstrFilter=f;
  if (!GetOpenFileName(&ofn)) return false;
  getmanifest();
  makebakname();
  HINSTANCE hTest=LoadLibraryEx(BakName,0,LOAD_LIBRARY_AS_DATAFILE);
  if (hTest) FreeLibrary(hTest);
  EnableMenuItem(hMainMenu,103,MF_ENABLED);
  EnableMenuItem(hMainMenu,104,hTest?MF_ENABLED:MF_GRAYED);
  TCHAR s[64];
  _sntprintf(s,elemof(s),TEXT("%s - %s"),ExeName+ofn.nFileOffset,MBoxTitle);
  SetWindowText(hMainWnd,s);
  return true;
}

static LONG_PTR CALLBACK MainWndProc(HWND Wnd,UINT msg,WPARAM wParam,LPARAM lParam) {
  switch (msg) {
    case WM_CREATE: {
      hMainWnd=Wnd;
      hMainMenu=GetMenu(Wnd);
      hStatus=CreateStatusWindow(WS_VISIBLE|WS_CHILD,TEXT("Status"),Wnd,13);
      hEdit=CreateWindowEx(0,RICHEDIT_CLASS,0,WS_CHILD|WS_VISIBLE|ES_MULTILINE|ES_AUTOHSCROLL|ES_AUTOVSCROLL|ES_WANTRETURN,
       0,0,0,0,Wnd,(HMENU)12,0,0);
      msgFind=RegisterWindowMessage(FINDMSGSTRING);
      findreplace.lStructSize=sizeof findreplace;
      findreplace.hwndOwner=Wnd;
      findreplace.Flags=FR_SHOWHELP|FR_DOWN;
      findreplace.lpstrFindWhat=findstr;
      findreplace.wFindWhatLen=elemof(findstr);
      findreplace.lpstrReplaceWith=replacestr;
      findreplace.wReplaceWithLen=elemof(replacestr);
    }break;
    case WM_SIZE: {
      SendMessage(hStatus,msg,wParam,lParam);
      RECT rc;
      static const int info[]={1,1,1,13,0};
      GetEffectiveClientRect(Wnd,&rc,const_cast<int*>(info));
      SetWindowPos(hEdit,0,rc.left,rc.top,rc.right-rc.left,rc.bottom-rc.top,SWP_NOZORDER);
    }break;
    case WM_INITMENU: {
      EnableMenuItem((HMENU)wParam,65,SendMessage(hEdit,EM_CANUNDO,0,0)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem((HMENU)wParam,66,SendMessage(hEdit,EM_CANREDO,0,0)?MF_ENABLED:MF_GRAYED);
    }break;
    case WM_COMMAND: switch (wParam) {
      case 65: SendMessage(hEdit,EM_UNDO,0,0); break;
      case 66: SendMessage(hEdit,EM_REDO,0,0); break;
      case 81: if (hFind) SetActiveWindow(hFind);
      else hFind=FindText(&findreplace);
      break;
      case 84: if (hFind) SetActiveWindow(hFind);
      else hFind=ReplaceText(&findreplace);
      break;
      case 101: openfile(Wnd); break;
      case 102: apply(Wnd); break;
      case 103: ShellExecute(Wnd,0,ExeName,0,0,SW_SHOWDEFAULT); break;
      case 104: revert(Wnd); break;
      case 2: SendMessage(Wnd,WM_CLOSE,0,0); break;
      case MAKELONG(12,EN_UPDATE): {
        EnableMenuItem(hMainMenu,102,Edit_GetModify((HWND)lParam)?MF_ENABLED:MF_GRAYED);
      }break;
    }break;
    case WM_NOTIFY: switch (wParam) {
      case 12: {
        NMHDR*nmhdr=(NMHDR*)lParam;
	switch (nmhdr->code) {
	  case EN_CHANGE: EnableMenuItem(hMainMenu,102,Edit_GetModify(nmhdr->hwndFrom)?MF_ENABLED:MF_GRAYED); break;
	}
      }break;
    }break;
    case WM_SETFOCUS: SetFocus(hEdit); break;
    case WM_CLOSE:
    case WM_QUERYENDSESSION: {
      if (!(GetMenuState(hMainMenu,102,0)&MF_GRAYED)) {
        switch (MBox(Wnd,9,MB_YESNOCANCEL|MB_ICONQUESTION|MB_SOUND,ExeName)) {
	  case IDCANCEL: return TRUE;	// don't save, Windows can terminate
	  case IDNO: return FALSE;	// don't save, don't let Windows terminate
	}
	apply(Wnd);			// save, then let Windows terminate
      }
    }break;
//    case WM_CLOSE: DestroyWindow(Wnd); break;
    case WM_DESTROY: PostQuitMessage(0); break;
    default: if (msg==msgFind) {
      FINDREPLACE&fr=*(FINDREPLACE*)lParam;
      if (fr.Flags&FR_DIALOGTERM) hFind=0;
      if (fr.Flags&FR_FINDNEXT) {
        UINT options=fr.Flags&(FR_DOWN|FR_MATCHCASE|FR_WHOLEWORD);
	FINDTEXTEX ft={{0,-1},fr.lpstrFindWhat};
        if (SendMessage(hEdit,EM_FINDTEXTEX,options,(LPARAM)&ft)>=0) {
	  Edit_SetSel(hEdit,ft.chrgText.cpMin,ft.chrgText.cpMax);
	}else MessageBeep(MB_ICONEXCLAMATION);
      }
    }
  }
  return DefWindowProc(Wnd,msg,wParam,lParam);
}

void WinMainCRTStartup() {
  hInstance=GetModuleHandle(0);
  InitCommonControls();
  LoadLibrary(TEXT("Riched20.dll"));
  WNDCLASS wc={
    CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS,
    MainWndProc,
    0,0,0,
    LoadIcon(0,IDI_APPLICATION),
    0,0,
    MAKEINTRESOURCE(100),
    MAKEINTATOM(100)
  };
  RegisterClass(&wc);
//  const TCHAR*cmdline=GetCommandLine();
//  const TCHAR*args=PathGetArgs(cmdline);
  LoadString(hInstance,1,MBoxTitle,elemof(MBoxTitle));
  HACCEL hAccel=LoadAccelerators(hInstance,MAKEINTRESOURCE(100));

  hMainWnd=CreateWindowEx(0,MAKEINTATOM(100),MBoxTitle,WS_OVERLAPPEDWINDOW,
    CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
    0,0,0,0);
  ShowWindow(hMainWnd,SW_SHOWDEFAULT);

  MSG msg;
  while (GetMessage(&msg,0,0,0)) {
    if (hAccel && TranslateAccelerator(hMainWnd,hAccel,&msg)) continue;
    if (hDialog && IsDialogMessage(hDialog,&msg)) continue;
    if (hFind && IsDialogMessage(hFind,&msg)) continue;
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  ExitProcess((UINT)msg.wParam);

}
